

  PROGRAM TER_MARS;

    { VERSION SPECIALEMENT ADAPTEE AU VOYAGE ELLIPTIQUE DE LA TERRE VERS VENUS
    EVITANT TOUTES LES QUESTIONS FASTIDIEUSES DU PROGRAMME PLUS GENERAL BIPOS

    UN PROGRAMME ANALOGUE AVEC LA TERRE ET MARS A ETE VERIFIE ET FONCTIONNE}
   
   {Declarations des unites utilisees dans le programme principal}

	 uses constype,jourjuli,wincrt,fonvect,fonscal,mercure,venus,terre,jupiter
        ,saturne,mars,neptune,uranus,rvparam;

   label LAB;

   {Ce logiciel determine la trajectoire keplerienne joignant la Terre et
   VENUS dans le repere j2000,en ne demandant que les dates de depart et
   d'arrivee .

   **********************************************************************
   *   NB:ATTENTION DONNEZ LES NOMS DE PLANETES EN minuscules           *
   **********************************************************************
     Notations utilisees:
       DEPART xd,yd,zd.
       ARRIVEE xa,ya,za.
       DATE DE DEPART datedepart sous la forme 09081987 pour le 9 aout
              1987,heure 120945 pour 12h9mn45s.
       DATE D'ARRIVEE date arrivee sous les memes formes.
     Resultats:
       PARAM:tableau des parametres orbitaux  partir desquels on peut
             calculer des vitesses etc...
             Dans l'ordre:
						 param[1]:demi grand-axe
             param[2]:excentricite
             param[3]:inclinaison orbitale
             param[4]:argument nodal du perigee
             param[5]:longitude vernale de la ligne des noeuds
             param[6]:anomalie excentrique
             param[7]:date julienne de premier passage au perigee
       NB:coordonnees et distance en km
          angles en radians dans les calculs et degres en sortie even-
          tuelle.

    En se referant a l'etude preliminaire on constate qu'il y a 6 cas
    de figures suivant trois criteres :

       MONTEE vers l'apogee:MONTE:=1 sinon MONTE:=-1}


    VAR param:tabparam;
        rd,ra,vd,va,x,y,w,vitdepart,vitarrivee,vitinfdep,vitinfar:vecteur;
        cas:integer;
        duree,p,ah,eh,ch,psia,psib,psiasymptote,alpha,monte,c3dep,c3ar:real;
        ae,ce,exc,fid,fia,dureecalculee,sensdirect,psilim1:real;
				chr:char;
        datedepart,heuredepart:string;
        conclusion:boolean;
 {*************************************************************************}

    PROCEDURE HYPERBOLE;

    const k:vecteur=(0,0,1);

    var mrd,result:vecteur;

   BEGIN

    {Mise en place des axes x et y unitaires}

      SCALVECT(-1,rd,mrd);

      SOMME(ra,mrd,result);

      UNITAIRE(result,x);

    {Calcul de w:unitaire normal au plan orbital et induisant le
		 mouvement}

      PRODVECT(rd,ra,w);

    {Test de non colinearite des rayons vecteurs depart et arrivee}

      alpha:=ANGVECT(rd,ra);
      if((alpha<1e-3) or (abs(pi-alpha)<1e-3)) then
      write('Theorie non applicable:trajectoire non unique');

      UNITAIRE(w,w);
      sensdirect:=1;
      if (PRODSCAL(w,k)<0) then
         begin
         SCALVECT(-1,w,w);
         sensdirect:=-1;
         end;
      PRODVECT(w,x,y);

    {Mise en place de l hyperbole,ch 1/2 axe focal,ah 1/2 grand-axe
     eh:excentricite,p parametre}

			ch:=NORM(result)/2;
      ah:=abs((NORM(ra)-NORM(rd)))/2;
      eh:=ch/ah;
      p:=ah*(eh*eh-1);

    {Calcul du 1/2 angle d ouverture des asymptotes et des angles en a,d,o }

      psiasymptote:=ARCCOS(1/eh);
   {Calcul des angles entre 0 et pi ,le cosinus est parfait}

      psia:=ARCCOS((4*ch*ch+Norm(rd)*Norm(rd)-Norm(ra)*Norm(ra))/4/ch/Norm(rd));
      psib:=pi-alpha-psia;

   END;

{***************************************************************************}

   PROCEDURE ELLIPSE(psi:real);

    var  rho,xo1,yo1,xo,yo:real;

    BEGIN

      {Calcul du 1/2 grand-axe ae,de la 1/2 distance focale ce,du rayon vecteur
       ro1 du second foyer de l ellipse,de l excentricite exc}

      if (NORM(ra)>Norm(rd)) then
       begin
        rho:=p/(1+eh*cos(psi));

        {Calcul des coordonnees de o1 dans les axes x et y}

         xo1:=ch-rho*cos(psi);
         yo1:=rho*sin(psi);

         {Calcul du demi grand-axe de l ellipse}

         ae:=(sqrt((xo1+ch)*(xo1+ch)+yo1*yo1)+NORM(rd))/2;

         if sensdirect<0 then psib:=-psib;

         {Calcul de la demi distance focale de l ellipse=OO1/2}
	 xo:=ch-NORM(ra)*cos(psib);
	 yo:=norm(ra)*sin(psib);
				 ce:=sqrt((xo1-xo)*(xo1-xo)+(yo1-yo)*(yo1-yo))/2;
              exc:=ce/ae;
         if sensdirect<0 then psib:=-psib;

      end;

    if (NORM(ra)<Norm(rd)) then
      begin
        rho:=p/(1+eh*cos(psi));

       {Calcul des coordonnees de o1 dans les axes x et y}

       xo1:=-ch+rho*cos(psi);
       yo1:=rho*sin(psi);

       {Calcul du demi grand-axe de l ellipse}

       ae:=(sqrt((xo1+ch)*(xo1+ch)+yo1*yo1)+NORM(rd))/2;

       if sensdirect<0 then psib:=-psib;

       {Calcul de la demi distance focale de l ellipse=OO1/2}
			 xo:=ch-NORM(ra)*cos(psib);
       yo:=norm(ra)*sin(psib);
       ce:=sqrt((xo1-xo)*(xo1-xo)+(yo1-yo)*(yo1-yo))/2;
            exc:=ce/ae;
       if sensdirect<0 then psib:=-psib;

    end;

   END;


{***************************************************************************}

  PROCEDURE LECTUREDONNEES;

  type chaine=string[7];
 label retour;
  const ensemble:array[1..8] of chaine =('mercure','venus','terre','mars',
      'jupiter','saturne','uranus','neptune');


  var  datearrivee,heurearrivee,rep:string;
       mj,sj,jjd,jja,jancd,janca:real;
       memecote,grand,monte,i,kd,ka:integer;
       bool:boolean;
       choix:chaine;
       paramplanete:tabparam;
       ch:char;

    BEGIN

 retour:
    rep:='non';

    while rep='non' do
    begin
     clrscr;

    {Calcul de la duree du voyage en jours de 86400 s.}
     writeln('                  RESOLUTION DU PROBLEME DE LAMBERT');
     writeln('         TRAJECTOIRE RELIANT 2 POINTS DONNES A 2 INSTANTS FIXES');
     writeln;
     writeln('     Attention les DONNEES ne sont PAS TESTEES');
     writeln;
     writeln('     Donnez date et heure sous la forme suivante:');
     writeln('     9 fevrier 1987 ----->09021987');
     writeln('     8h5mn34s ------>080534');
     writeln;
     write('     Date de depart=?');readln(datedepart);writeln;
     write('     Date d arrivee=?');readln(datearrivee);writeln;

     write('     Heure de depart=?');readln(heuredepart);writeln;
     write('     Heure d arrivee=?');readln(heurearrivee);writeln;
     writeln;
     datejuli(datedepart,heuredepart,mj,sj,jjd,jancd);
     datejuli(datearrivee,heurearrivee,mj,sj,jja,janca);
     duree:=jja-jjd;

     {Sortie du resultat pour confirmation}
     writeln;
     writeln('     La duree du voyage est de ',duree:8:3,' jours juliens');
     writeln;
     writeln;
     writeln('     Date julienne reference 2000 du depart',jancd-2451545);
     writeln('     Date julienne reference 2000 d arrivee',janca-2451545);
     writeln;


     {Test de verification des donnees}

     rep:='ouinon';

     while (not((rep='n') or (rep='o'))) do
     begin
      write('     Vos donnees sont-elles correctes(o/n)?:reponse=');
      readln(rep);
      if rep='n' then goto retour;
     end;

   end;




      kd:=3;

 {Appel des ephemerides pour le point de depart si necessaire}

     case kd of
	 1:ephemmercure(datedepart,heuredepart,mus,1,paramplanete,rd,vd);
	 2:ephemvenus(datedepart,heuredepart,mus,1,paramplanete,rd,vd);
	 3:ephemterre(datedepart,heuredepart,mus,1,paramplanete,rd,vd);
	 4:ephemmars(datedepart,heuredepart,mus,1,paramplanete,rd,vd);
	 5:ephemjupiter(datedepart,heuredepart,mus,1,paramplanete,rd,vd);
         6:ephemsaturne(datedepart,heuredepart,mus,1,paramplanete,rd,vd);
	 7:ephemuranus(datedepart,heuredepart,mus,1,paramplanete,rd,vd);
	 8:ephemneptune(datedepart,heuredepart,mus,1,paramplanete,rd,vd);
       end;

	ka:=2;

 {Appel des ephemerides pour le point d arrivee si necessaire}

      case ka of
	 1:ephemmercure(datearrivee,heurearrivee,mus,1,paramplanete,ra,va);
	 2:ephemvenus(datearrivee,heurearrivee,mus,1,paramplanete,ra,va);
	 3:ephemterre(datearrivee,heurearrivee,mus,1,paramplanete,ra,va);
	 4:ephemmars(datearrivee,heurearrivee,mus,1,paramplanete,ra,va);
	 5:ephemjupiter(datearrivee,heurearrivee,mus,1,paramplanete,ra,va);
	 6:ephemsaturne(datearrivee,heurearrivee,mus,1,paramplanete,ra,va);
	 7:ephemuranus(datearrivee,heurearrivee,mus,1,paramplanete,ra,va);
	 8:ephemneptune(datearrivee,heurearrivee,mus,1,paramplanete,ra,va);
      end;



     writeln('     ****************SORTIE DES RESULTATS*************************');
     duree:=duree*86400;

  END;

 {*************************************************************************}


  PROCEDURE TEMPS(var ae,exc,t,fid,fia:real);

   var tempo:real;

   {Calcul des anomalies excentriques fid au depart et fia a l arrivee}

   BEGIN

   fid:=ARCCOS((1-NORM(rd)/ae)/exc);
   fia:=ARCCOS((1-NORM(ra)/ae)/exc);

   {Calcul du temps de voyage en jours suivant les cas}

   tempo:=ae*sqrt(ae/mus);

    case  cas of
           1:t:=tempo*(fia-fid-exc*(sin(fia)-sin(fid)));
           2:begin
	       t:=tempo*(fid+fia-exc*(sin(fid)+sin(fia)));
               fid:=2*pi-fid;
	      end;
           3:begin
	       t:=tempo*(2*pi-fid-fia+exc*(sin(fid)+sin(fia)));
               fia:=2*pi-fia;
             end;
           4:begin
               t:=tempo*(fid+fia-exc*(sin(fid)+sin(fia)));
							 fid:=2*pi-fid;
               end;
           5:begin
               t:=tempo*(2*pi+fid-fia-exc*(sin(fid)-sin(fia)));
               fia:=2*pi-fia;
               fid:=2*pi-fid;
             end;
           6:begin
               t:=tempo*(2*pi-fid-fia-exc*(sin(fia)-sin(fid)));
               fia:=2*pi-fia;
             end;
	   7:begin
	       t:=tempo*(fia+fid-exc*(sin(fia)+sin(fid)));
               fid:=2*pi-fid;
             end;
           8:begin
               t:=tempo*(fid-fia-exc*(sin(fid)-sin(fia)));
               fid:=2*pi-fid;
               fia:=2*pi-fia;
             end;
           9:begin
               t:=tempo*(2*pi-fia-fid+exc*(sin(fia)+sin(fid)));
							 fia:=2*pi-fia;
             end;
           10:begin
               t:=tempo*(2*pi-fid-fia+exc*(sin(fid)+sin(fia)));
               fia:=2*pi-fia;
              end;
           11:t:=tempo*(2*pi-fid+fia+exc*(sin(fid)-sin(fia)));
           12:begin
                t:=tempo*(fia+fid-exc*(sin(fia)+sin(fid)));
                fid:=2*pi-fid;
              end;
    end;

  END;
{**************************************************************************}

  PROCEDURE ANGLELIMITEMONTANT(var psilim1:real);

 var k,xa,xb,xc,ki1,ki2,psi1,psi2:real;

  BEGIN

	if(NORM(ra)>NORM(rd)) then
   begin
     k:=2*eh/(eh*eh-1);
     xa:=sin(psia)-k*eh;
     xb:=cos(psia);
     xc:=sqrt(xa*xa+xb*xb);
     ki1:=ARCSIN(xa/xc);
     ki2:=ARCSIN(k/xc);
     psi1:=ki2-ki1;
     psi2:=pi-ki2-ki1;

     if ((psi1>psib) and (psi1<pi-psiasymptote)) then psilim1:=psi1;
     if ((psi2>psib) and (psi2<pi-psiasymptote)) then psilim1:=psi2;
   end;

  if (NORM(ra)<NORM(rd)) then
   begin

     k:=2*eh/(eh*eh-1);
     xa:=sin(psib)-k*eh;
     xb:=cos(psib);
     xc:=sqrt(xa*xa+xb*xb);
		 ki1:=ARCSIN(xa/xc);
     ki2:=ARCSIN(k/xc);
     psi1:=ki2-ki1;
     psi2:=pi-ki2-ki1;

     if ((psi1>psia) and (psi1<pi-psiasymptote)) then psilim1:=psi1;
     if ((psi2>psia) and (psi2<pi-psiasymptote)) then psilim1:=psi2;
  end;

  END;


{*************************************************************************}

 PROCEDURE ITERATION(psimin,psimax:real;var conclusion:boolean);

    label lab1,lab2,lab3;

   var psi,tmin,tmax,t,deltat,deltapsi:real;
       i:integer;
       tvoy:array[0..51] of real;
       chr:char;

      BEGIN
        {Tant que conclusion =false la solution n est pas trouvee}

        conclusion:=false;

     {INITIALISATION DE LA BOUCLE DE CALCUL DE LA SOLUTION}

     lab1:deltapsi:=(psimax-psimin)/50;
          i:=1;

     lab2:begin
          {Calcul de la duree en debut d intervalle }

               psi:=psimin+(i-1)*deltapsi;
               ellipse(psi);
	       temps(ae,exc,tvoy[i],fid,fia);
               if(abs(duree-tvoy[i])<60) then
                begin
                  dureecalculee:=tvoy[i];
                  conclusion:=true;
                  goto lab3;
								end;
          {Calcul de la duree en fin de l intervalle}

               psi:=psimin+i*deltapsi;
               ellipse(psi);
               temps(ae,exc,tvoy[i+1],fid,fia);

               if(abs(duree-tvoy[i+1])<60) then
                begin
                  dureecalculee:=tvoy[i+1];
                  conclusion:=true;
                  goto lab3;
                end;
          {Condition de changement de signe:solution localisee}
              if ((duree-tvoy[i])*(duree-tvoy[i+1])<0) then
                   begin
                     psimax:=psi;
                     psimin:=psi-deltapsi;
                     goto lab1;
                   end;

             end;
								i:=i+1;
                if (i<51) then goto lab2;

      lab3:END;

 {*************************************************************************}

  PROCEDURE VITESSEDEPARTARRIVEE;

  {Cette procedure calcule aupoint d de depart la vitesse de la sonde,par
  ses composantes dans le repere J2000 en km/s.
   On pourra donc ensuite avec l unite RVPARAM calculer les parametres
	 orbitaux de la sonde}

   var  k1:real;
        p1,p2,punit,qunit:vecteur;
   BEGIN
       K1:=(sin(fia)*(cos(fid)-exc)- sin(fid)*(cos(fia)-exc))*ae;
       SCALVECT(sin(fia),rd,p1);
       SCALVECT(-sin(fid),ra,p2);
       SOMME(p1,p2,punit);
       SCALVECT(1/k1,punit,punit);
			 PRODVECT(w,punit,qunit);

    {Calcul de la vitesse de depart(voir cnes p 62)}

       k1:=-sqrt(mus/(ae*sqr(ae)))*sin(fid)*ae/(1-exc*cos(fid));
       SCALVECT(k1,punit,p1);
       k1:=sqrt(mus/(ae*sqr(ae)))*cos(fid)*sqrt(1-exc*exc)*ae/
			       (1-exc*cos(fid));
       SCALVECT(k1,qunit,p2);
       SOMME(p1,p2,vitdepart);

    {Calcul de la vitesse d arrivee(voir cnes p 62)}

       k1:=-sqrt(mus/(ae*sqr(ae)))*sin(fia)*ae/(1-exc*cos(fia));
       SCALVECT(k1,punit,p1);
       k1:=sqrt(mus/(ae*sqr(ae)))*cos(fia)*sqrt(1-exc*exc)*ae/
			       (1-exc*cos(fia));
       SCALVECT(k1,qunit,p2);
       SOMME(p1,p2,vitarrivee);

   END;
 {**************************************************************************}
 PROCEDURE SORTIEFINALE ;

 BEGIN

     writeln('     Duree du voyage entre dates= ',duree,' en secondes');
     writeln('                                = ',duree/86400,' en jours');
     writeln;
     writeln('     Duree du voyage calculee =',dureecalculee,' en secondes');
     writeln('                              =',dureecalculee/86400:7:2,' en jours');
     writeln;
     writeln('     La vitesse de tir au depart est donnee par ses composantes');
     writeln('     en km/s dans le repere J2000');
     writeln;
     writeln('     Sur I---------->VDEPART(1)=',vitdepart[1]:7:3, ' km/s');
     writeln('     Sur J---------->VDEPART(2)=',vitdepart[2]:7:3, ' km/s');
     writeln('     Sur K---------->VDEPART(3)=',vitdepart[3]:7:3, ' km/s');writeln;

     writeln('     La vitesse de tir a l arrivee est donnee par ses composantes');
     writeln('     en km/s dans le repere J2000');
     writeln;
     writeln('     Sur I---------->VARRIVEE(1)=',vitarrivee[1]:7:3, ' km/s');
     writeln('     Sur J---------->VARRIVEE(2)=',vitarrivee[2]:7:3, ' km/s');
     writeln('     Sur K---------->VARRIVEE(3)=',vitarrivee[3]:7:3, ' km/s');writeln;

     writeln('              Pour continuer appuyer sur une touche');
     writeln;
     writeln('       ATTENTION LES RESULTATS VONT S EFFACER,NOTEZ LES');
     chr:=readkey;
     clrscr;

   {Calcul des parametres orbitaux grace a la position-vitesse en utilisant
   l unite RVPARAM}

    POSVITPARAM(rd,vitdepart,datedepart,heuredepart,mus,param);

    writeln('     Voici les parametres orbitaux de la trajectoire de tir de ');
    writeln('     caracteristiques suivantes:');writeln;
    writeln('     DEMI GRAND-AXE= ',param[1]/1e6:8:3,' e6 km');
    writeln('     EXCENTRICITE= ',param[2]:7:5);
    writeln('     INCLINAISON ORBITALE SUR L ECLIPTIQUE= ',param[3]*180/pi:6:2,' degres');
    writeln('     ARGUMENT NODAL DU PERIGEE= ',param[4]*180/pi:6:2,' degres');
    writeln('     LONGITUDE VERNALE= ',param[5]*180/pi:6:2,' degres');
    writeln('     ANOMALIE EXCENTRIQUE DU DEPART= ',param[6]*180/pi:6:2,' degres');

    chr:=readkey;

  END;
 {************************************************************************}

  PROCEDURE RESULTATS;
   BEGIN
      VITESSEDEPARTARRIVEE;
      SORTIEFINALE;
      clrscr;

   END;
{***************************************************************************}

 PROCEDURE SEPARATION_CAS_DE_MONTEE;

 LABEL lab4;

 VAR angle,psiinf,psisup,xra,xrd:real;

  BEGIN
    xra:=norm(ra);
    xrd:=norm(rd);

   {Calcul de l'angle maximum sur psi qui limite la distance AO1  5 E9 KM}
    angle:=0.99*(pi-psiasymptote);

    psiinf:=-angle;
    psisup:=angle;

    if ((xra>xrd) and (psia<psiasymptote) and (sensdirect>0))
       then
          begin
           ANGLELIMITEMONTANT(psilim1);
           if (psilim1<psisup)
                then
                   begin
                      cas:=2;
                      ITERATION(psilim1,psisup,conclusion);
		      if conclusion then
                        begin
                         RESULTATS;
                         goto lab4;
                        end;
                   end;
					end;

    {Le cas 2 est epuise,on envisage les autres cas}

    if (xra>xrd) and (sensdirect>0) then
       begin
         cas:=1;
         ITERATION(psib,psisup,conclusion);
         if conclusion then
            begin
	      RESULTATS;
	      goto lab4;
            end;
       end;

       if(xra>xrd) and (sensdirect>0) then
         begin
           cas:=3;
           ITERATION(psiinf,psib,conclusion);
           if conclusion then
             begin
               RESULTATS;
							 goto lab4;
             end;
           if not(conclusion) then goto lab4;

         end;
                       {************************}

    if ((xra>xrd) and (psia<psiasymptote) and (sensdirect<0))
       then
          begin
           ANGLELIMITEMONTANT(psilim1);
           if (psilim1<psisup)
                then
                   begin
                      cas:=6;
                      ITERATION(psiinf,-psilim1,conclusion);
                      if conclusion
                         then
                          begin
			    RESULTATS;
			    goto lab4;
                         end;
										end;
         end;

    {Le cas 6 est epuise,on envisage les autres cas}

    if (xra>xrd) and (sensdirect<0) then
       begin
         cas:=5;
         ITERATION(psiinf,-psib,conclusion);
         if conclusion then
            begin
              RESULTATS;
	      goto lab4;

           end;
       end;

       if(xra>xrd) and (sensdirect<0) then
         begin
           cas:=4;
           ITERATION(-psib,psisup,conclusion);
           if conclusion then
						 begin
               RESULTATS;
               goto lab4;
             end;
           if not(conclusion) then goto lab4;

	 end;


  lab4:END;
  {***********************************************************************}

  PROCEDURE SEPARATION_CAS_DE_DESCENTE;

 LABEL lab5;

 VAR angle,psiinf,psisup,xra,xrd:real;

 BEGIN
    xra:=norm(ra);
    xrd:=norm(rd);
    {Calcul de l'angle maximum sur psi qui limite la distance AO1  5 E9 KM}
		angle:=0.99*(pi-psiasymptote);

    psiinf:=-angle;
    psisup:=angle;

    if ((xra<xrd) and (psib<psiasymptote) and (sensdirect>0))
       then
          begin
           ANGLELIMITEMONTANT(psilim1);
           if (psilim1<psisup)
                then
                   begin
                      cas:=7;
                      ITERATION(psilim1,psisup,conclusion);
                      if conclusion
			 then
			  begin
                            RESULTATS;
                            goto lab5;
                         end;
                  end;
          end;

    {Le cas 7 est epuise,on envisage les autres cas}

    if (xra<xrd) and (sensdirect>0) then
       begin
         cas:=8;
         ITERATION(psia,psisup,conclusion);
         if conclusion then
	    begin
              RESULTATS;
              goto lab5;

           end;
       end;

       if(xra<xrd) and (sensdirect>0) then
         begin
           cas:=9;
           ITERATION(psiinf,psib,conclusion);
           if conclusion then
             begin
               RESULTATS;
							 goto lab5;
             end;
	   if not(conclusion) then goto lab5;

         end;
                       {************************}

    if ((xra<xrd) and (psib<psiasymptote) and (sensdirect<0))
       then
          begin
           ANGLELIMITEMONTANT(psilim1);
           if (psilim1<psisup)
                then
                   begin
                      cas:=10;
                      ITERATION(psiinf,-psilim1,conclusion);
                      if conclusion
                         then
                          begin
                            RESULTATS;
                            goto lab5;
                         end;
									 end;
          end;

    {Le cas 10 est epuise,on envisage les autres cas}

    if (xra<xrd) and (sensdirect<0) then
       begin
         cas:=11;
         ITERATION(psiinf,-psia,conclusion);
         if conclusion then
            begin
	      RESULTATS;
	      goto lab5;

            end;
       end;

       if(xra<xrd) and (sensdirect<0) then
         begin
           cas:=12;
           ITERATION(-psia,psisup,conclusion);
           if conclusion then
						 begin
               RESULTATS;
               goto lab5;
             end;
           if not(conclusion) then goto lab5;

         end;


  lab5:END;
 {************************************************************************}
  PROCEDURE COMMENTAIRES;

  var xra,xrd,apo,peri,angle:real;

  BEGIN
   xra:=norm(ra);
   xrd:=norm(rd);
   apo:=ae*(1+exc);
   peri:=ae*(1-exc);
   angle:=alpha*180/pi;
   if sensdirect<0 then angle:=360-angle;

   case cas of
      1:begin
	 writeln;
	 writeln('     CAS DE MONTEE');
	 writeln('     RAYON VECTEUR AU DEPART :',xrd/1e6:8:3,' e6 KM');
	 writeln('     RAYON VECTEUR A L''ARRIVEE :',xra/1e6:8:3,' e6 KM');
	 writeln('     ANGLE BALAYE PAR LE RAYON VECTEUR :',angle:6:2,'DEGRES');
	end;
      2:begin
	 writeln;
	 writeln('     CAS DE MONTEE');
	 writeln('     RAYON VECTEUR AU DEPART :',xrd/1e6:8:3,' e6 KM');
	 writeln('     PASSAGE PAR LE PERIGEE A :',peri/1e6:8:3,' e6 KM');
	 writeln('     RAYON VECTEUR A L''ARRIVEE :',xra/1e6:8:3,'e6 KM');
	 writeln('     ANGLE BALAYE PAR LE RAYON VECTEUR :',angle:6:2,' DEGRES');
	end;
      3:begin
	 writeln;
	 writeln('     CAS DE MONTEE');
	 writeln('     RAYON VECTEUR AU DEPART :',xrd/1e6:8:3,' e6 KM');
	 writeln('     PASSAGE PAR L''APOGEE A :',APO/1e6:8:3,' e6 KM');
	 writeln('     RAYON VECTEUR A L''ARRIVEE :',xra/1e6:8:3,' e6 KM');
	 writeln('     ANGLE BALAYE PAR LE RAYON VECTEUR :',angle:6:2,' DEGRES');
	end;
      4:begin
	 writeln;
	 writeln('     CAS DE MONTEE');
	 writeln('     RAYON VECTEUR AU DEPART :',xrd/1e6:8:3,' e6 KM');
	 writeln('     PASSAGE PAR LE PERIGEE A :',peri/1e6:8:3,' e6 KM');
	 writeln('     RAYON VECTEUR A L''ARRIVEE :',xra/1e6:8:3,' e6 KM');
	 writeln('     ANGLE BALAYE PAR LE RAYON VECTEUR :',angle:6:2,' DEGRES');
	end;
     5:begin
	 writeln;
	 writeln('     CAS DE MONTEE');
	 writeln('     RAYON VECTEUR AU DEPART :',xrd/1e6:8:3,' e6 KM');
	 writeln('     PASSAGE PAR LE PERIGEE A :',peri/1e6:8:3,' e6 KM');
	 writeln('     PASSAGE PAR L''APOGEE A :',apo/1e6:8:3,' e6 KM');
	 writeln('     RAYON VECTEUR A L''ARRIVEE :',xra/1e6:8:3,' e6 KM');
	 writeln('     ANGLE BALAYE PAR LE RAYON VECTEUR :',angle:6:2,' DEGRES');
	end;
      6:begin
	 writeln;
	 writeln('     CAS DE MONTEE');
	 writeln('     RAYON VECTEUR AU DEPART :',xrd/1e6:8:3,' e6 KM');
	 writeln('     PASSAGE PAR L''APOGEE A :',apo/1e6:8:3,' e6 KM');
	 writeln('     RAYON VECTEUR A L''ARRIVEE :',xra/1e6:8:3,' e6 KM');
	 writeln('     ANGLE BALAYE PAR LE RAYON VECTEUR :',angle:6:2,' DEGRES');
	end;
      7:begin
	 writeln;
	 writeln('     CAS DE DESCENTE');
	 writeln('     RAYON VECTEUR AU DEPART :',xrd/1e6:8:3,' e6 KM');
	 writeln('     PASSAGE PAR LE PERIGEE A :',peri/1e6:8:3,' e6 KM');
	 writeln('     RAYON VECTEUR A L''ARRIVEE :',xra/1e6:8:3,' e6 KM');
	 writeln('     ANGLE BALAYE PAR LE RAYON VECTEUR :',angle:6:2,' DEGRES');
	end;
      8:begin
	 writeln;
	 writeln('     CAS DE DESCENTE');
	 writeln('     RAYON VECTEUR AU DEPART :',xrd/1e6:8:3,' e6 KM');
	 writeln('     RAYON VECTEUR A L''ARRIVEE :',xra/1e6:8:3,' e6 KM');
	 writeln('     ANGLE BALAYE PAR LE RAYON VECTEUR :',angle:6:2,' DEGRES');
	end;
      9:begin
	 writeln;
	 writeln('     CAS DE DESCENTE');
	 writeln('     RAYON VECTEUR AU DEPART :',xrd/1e6:8:3,' e6 KM');
	 writeln('     PASSAGE PAR L''APOGEE A :',apo/1e6:8:3,' e6 KM');
	 writeln('     RAYON VECTEUR A L''ARRIVEE :',xra/1e6:8:3,' e6 KM');
	 writeln('     ANGLE BALAYE PAR LE RAYON VECTEUR :',angle:6:2,' DEGRES');
	end;
      10:begin
	 writeln;
	 writeln('     CAS DE DESCENTE');
	 writeln('     RAYON VECTEUR AU DEPART :',xrd/1e6:8:3,' e6 KM');
	 writeln('     PASSAGE PAR L''APOGEE A :',apo/1e6:8:3,' e6 KM');
	 writeln('     RAYON VECTEUR A L''ARRIVEE :',xra/1e6:8:3,' e6 KM');
	 writeln('     ANGLE BALAYE PAR LE RAYON VECTEUR :',angle:6:2,' DEGRES');
	end;
      11:begin
	 writeln;
	 writeln('     CAS DE DESCENTE');
	 writeln('     RAYON VECTEUR AU DEPART :',xrd/1e6:8:3,' e6 KM');
	 writeln('     PASSAGE PAR L''APOGEE A :',apo/1e6:8:3,' e6 KM') 	 ;
	 writeln('     PASSAGE PAR LE PERIGEE A :',peri/1e6:8:3,' e6 KM');
	 writeln('     RAYON VECTEUR A L''ARRIVEE :',xra/1e6:8:3,' e6 KM');
	 writeln('     ANGLE BALAYE PAR LE RAYON VECTEUR :',angle:6:2,' DEGRES');
	end;
      12:begin
	 writeln;
	 writeln('     CAS DE DESCENTE');
	 writeln('     RAYON VECTEUR AU DEPART :',xrd/1e6:8:3,' e6 KM');
	 writeln('     PASSAGE PAR LE PERIGEE A :',peri/1e6:8:3,' e6 KM');
	 writeln('     RAYON VECTEUR A L''ARRIVEE :',xra/1e6:8:3,' e6 KM');
	 writeln('     ANGLE BALAYE PAR LE RAYON VECTEUR :',angle:6:2,' DEGRES');
	end;
     end;

   END;
 {**********************************************************************}
  PROCEDURE VITESSE_INFINIE;

   BEGIN

    vitinfdep[1]:=vitdepart[1]-vd[1];
    vitinfdep[2]:=vitdepart[2]-vd[2];
    vitinfdep[3]:=vitdepart[3]-vd[3];

    vitinfar[1]:=vitarrivee[1]-va[1];
    vitinfar[2]:=vitarrivee[2]-va[2];
    vitinfar[3]:=vitarrivee[3]-va[3];

  END;


 {************************************************************************

                       PROGRAMME PRINCIPAL

  ************************************************************************}

 BEGIN
 clrscr;

 LECTUREDONNEES;

 HYPERBOLE;

 if NORM(ra)>NORM(rd)  then SEPARATION_CAS_DE_MONTEE;
 if NORM(ra)<Norm(rd) then SEPARATION_CAS_DE_DESCENTE;

 if (((abs(fia)<1e-2) or(abs(fia-pi)<1e-2)) and conclusion) then
    writeln('     NB:L''ARRIVEE A LIEU PRATIQUEMENT A L''APOGEE');
 if (((abs(fid)<1e-2) or(abs(fid-pi)<1e-2)) and conclusion) then
    writeln('     NB:L''ARRIVEE A LIEU PRATIQUEMENT AU PERIGEE');
 writeln;writeln;
 if not(conclusion) then
   writeln('     AUCUN VOYAGE ELLIPTIQUE N''EST POSSIBLE:DUREE TROP COURTE');
 if conclusion then
   begin
     writeln('                       CAS DE VOL N ',cas);
     writeln;writeln;
     writeln('                       CONDITIONS DU VOL');
     COMMENTAIRES;
     writeln;
     VITESSE_INFINIE;
     C3DEP:=sqr(NORM(vitinfdep));
     C3AR:=sqr(NORM(vitinfar));
     writeln('     COMPOSANTES DE LA VITESSE INFINIE AU DEPART ');
     writeln('     vitinfdep[1] =',vitinfdep[1]:6:3,' KM/S');
     writeln('     vitinfdep[2] =',vitinfdep[2]:6:3,' KM/S');
     writeln('     vitinfdep[3] =',vitinfdep[3]:6:3,' KM/S');
     writeln('                              C3(depart)= ',C3DEP:7:2, ' km2/s2');
     writeln;
     writeln('     COMPOSANTES DE LA VITESSE INFINIE AU POINT ARRIVEE');
     writeln('     vitinfar[1] =',vitinfar[1]:6:3,' KM/S');
     writeln('     vitinfar[2] =',vitinfar[2]:6:3,' KM/S');
     writeln('     vitinfar[3] =',vitinfar[3]:6:3,' KM/S');
     writeln('                              C3(arrivee)= ',C3AR:7:2, ' km2/s2');
     writeln;
   end;
    writeln('                   appuyez sur une touche pour finir');

    chr:=READKEY;
		DoneWinCrt;
END.



