/**************************************************************************
***************************************************************************
			PROBLEME DE LAMBERT
		PROGRAMME CONTENANT LES FONCTIONS DE SAISIE
			ET LES FONCTIONS D'AFFICHAGE
***************************************************************************
**************************************************************************/



#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>

#define pi 3.141592654

extern void prodvect (double [],double [], double []);
extern double norme (double []);
extern double angle_vecteur( double [], double []);
extern void multiplication_scalaire (double, double [], double[]);
extern double solution_equation_elliptique_0_tour ();
extern double Solution_du_probleme(double);
extern double classification_des_cas();
extern void traitement_cas_vol(int );
extern void dernier_parametre ();
extern double premiere_solution_NTour();
extern double deuxieme_solution_NTour();
extern void ephemeride();
extern void saisie_coord();
extern void planete_coord();
extern void coord_planete();
extern void solution_elliptique();


extern double DureeMini;
extern double a;
extern double excentricite;
extern double ra, rp;
extern double argument;
extern double inclinaison;
extern double longitude;
extern double M;
extern double vitesse1[];
extern double vitesse2[];
extern double V[];
extern double phi1,phi2;
extern double teta1,teta2;
extern double Nvitesse1,Nvitesse2;
extern double gamma1,gamma2;
extern double Vinfini1,Vinfini2;
extern int cas_de_vol;


double RayonVecteurDepart[4];
double RayonVecteurArrivee[4];
double W12[4], W[4];
double Delta_T;
double AxeI[4], AxeJ[4], AxeK[4];
double R1, R2, S, D, Angle, Delta, Lambda;
double Mu;
int NTour;
int Helios;
int SensParcours,RetourDebut,Choix_Vol_Long_Court;
int reponse;
int planete1,planete2;

char nom_mission[20];
int longueur=0;
char nom='o';
char azerty;

char encore;
double choix;

/***************************************************************************
			FONCTION DE SAISIE
			ET QUELQUES CALCULS
***************************************************************************/



void saisir ()
{
	planete1=0;
	planete2=0;


	printf ("\n");
	printf("*******************************************************************************\n");
	printf("**                      PROJET: RESOLUTION DU PROBLEME DE LAMBERT            **\n");
	printf("**	 		  EMILIE CASTELLANI ET ISABELLE DAUVIN               **\n");
	printf("**	                    PROMOTION 2002/2003 DU DESS TAE                  **\n");
	printf("*******************************************************************************\n");
	printf("\n");




	//CHOIX DU NOM DE LA MISSION EVENTUELLEMENT


	while ((nom=='o')||(nom=='O'))
	{

	printf("Voulez-vous donner un nom  la mission? (o/n):");
	scanf("%c",&nom);
	azerty=nom;
	if ((nom=='O')||(nom=='o'))
		{
		nom='n';
		printf("\n\nEntrer le nom de la mission (20 caractres au maximum):\n");
		getchar();

		gets(nom_mission);
		}

	}


	/* CHOIX DU VOL HELIOCENTRIQUE OU GEOCENTRIQUE*/
	/* Seule varie la valeur de Mu */


	Helios=0;


	printf("\n\nVoulez-vous un vol gocentrique (taper 0) ou un vol hliocentrique (taper 1)? ");
	scanf("%d",&Helios);

	while ( (Helios!=1) && (Helios!=0))
	{
		printf("Vous avez fait un mauvais choix! Recommencez.\n");

		printf("\n");
		printf("Voulez-vous un vol gocentrique (taper 0) ou un vol hliocentrique (taper 1)? ");
		scanf("%d",&Helios);
	}

	if (Helios==1)
		Mu=13.271244e10;

	if (Helios==0)
		Mu=39.860064e4;



	/* SAISIE DES POINTS DE DEPART ET D'ARRIVEE  */

	RetourDebut=0;
	while (RetourDebut==0)
	{
		reponse=0;

		printf("\n");

/*	do
	{
	printf("Vous pouvez:\n\n");
	printf("choix 1: entrer les coordonnes des points de dpart et d'arrive\n"),
	printf("choix 2: entrer le nom des plantes de dpart et d'arrive\n");
	printf("choix 3: choisir une plante de dpart et entrer les coordonnes d'arrive.\n");
	printf("choix 4: entrer les coordonnes de dpart et choisir une plante d'arrive.\n\n");

	printf("ATTENTION: dans les choix 2,3 et 4, Pluton n'est pas une plante accessible!!!\n\n");
	printf("Quel est votre choix (1, 2, 3, 4)? ");
	scanf ("%d",&reponse);
	printf("\n");
	}
	while ((reponse!=1)&&(reponse!=2)&&(reponse!=3)&&(reponse!=4));

	if (reponse==1) saisie_coord();

	if (reponse==2) {ephemeride();planete1=1;planete2=1;}

	if (reponse==3) {planete_coord();planete1=1;}

	if (reponse==4) {coord_planete();planete2=1;}
*/


     saisie_coord();


     //RayonVecteurDepart[1]=89977.81;
     //RayonVecteurDepart[2]=54044.81;
     //RayonVecteurDepart[3]=-52998.54;
     //RayonVecteurArrivee[1]=65206.59;
     //RayonVecteurArrivee[2]=35375.58;
     //RayonVecteurArrivee[3]=-37206.90;




	/* VERIFICATION DE LA NON COLINEARITE DES VECTEURS DE DEPART ET D'ARRIVEE */

	prodvect(RayonVecteurDepart, RayonVecteurArrivee, W12);
	if (W12[3]>0) SensParcours=1;
		      else SensParcours=0;

	if (norme(W12)>0) RetourDebut=1;

	if (norme(W12)==0)
	{
	printf("Les points de dpart, d'arrive et le corps central sont aligns.\n");
	printf("C'est un cas singulier que nous ne traitons pas.\n\n\n");
	RetourDebut=0;
	}
	}



	/* SAISIE DE LA DUREE DU PARCOURS */

	printf("\n");
	printf("Entrer la dure souhaite du parcours EN JOURS DECIMAUX: ");
	scanf("%lf", &Delta_T);

	while(Delta_T<0)
	{
	printf ("Vous avez rentr un temps ngatif!!! Veuillez recommencer.\n\n");
	printf("Entrer la dure souhaite du parcours EN JOURS DECIMAUX: ");
	scanf("%lf", &Delta_T);
	}


	/* CHOIX DU NOMBRE DE TOURS */
	int tour=1;

	while(tour==1)
	{
	printf("\nCombien de tours voulez-vous faire (4 au maximum)? ");

	scanf("%d",&NTour);

	if ((NTour>=0) && (NTour<4)) tour=0;
	}



	/* DEFINITION DES AXES I , J ET K */

	AxeI[1]=1;
	AxeI[2]=0;
	AxeI[3]=0;

	AxeJ[1]=0;
	AxeJ[2]=1;
	AxeJ[3]=0;

	AxeK[1]=0;
	AxeK[2]=0;
	AxeK[3]=1;




	/* CALCULS INTERMEDIAIRES  */

	/* Calcul de la norme du vecteur de depart et d'arrivee */
	R1=norme(RayonVecteurDepart);
	R2=norme(RayonVecteurArrivee);
	/* Angle entre les vecteurs de depart et d'arrivee */
	Angle=angle_vecteur(RayonVecteurDepart, RayonVecteurArrivee);
	D=sqrt(R1*R1+R2*R2-2*R1*R2*cos(Angle));
	S=(R1+R2+D)/2;


	/* CHOIX D'UN VOYAGE LONG OU COURS */
	printf("\n\n");


	if (Helios==1)
	{
		if (SensParcours==1)
		{
		printf("Voulez-vous un vol court dans le sens des plantes (entrer 1) ou long dans le sens contraire (entrer 2)? ");
		scanf("%d",&Choix_Vol_Long_Court);

		while ((Choix_Vol_Long_Court!=1) && (Choix_Vol_Long_Court!=2))
		{
		printf("\nVous avez fait un mauvais choix. Recommencer.\n");
		printf("Voulez-vous un vol court dans le sens des plantes (entrer 1) ou long dans le sens contraire (entrer 2)? ");
		scanf("%d",&Choix_Vol_Long_Court);
		}
		}

		if (SensParcours==0)
		{
			printf("Voulez-vous un vol long dans le sens des plantes (entrer 3) ou court dans le sens contraire (entrer 4)? ");
			scanf("%d",&Choix_Vol_Long_Court);

			while ((Choix_Vol_Long_Court!=3) && (Choix_Vol_Long_Court!=4))
			{
			printf("\nVous avez fait un mauvais choix. Recommencer.\n");
			printf("Voulez-vous un vol long dans le sens des plantes (entrer 3) ou court dans le sens contraire (entrer 4)? ");
			scanf("%d",&Choix_Vol_Long_Court);
			}
		}
	}


	if (Helios==0)
	{
		if (SensParcours==1)
		{
		printf("Voulez-vous un vol: court (inclinaison<90 entrer 1)\n");
		printf("                    ou long (inclinaison>=90 entrer 2)? ");
		scanf("%d",&Choix_Vol_Long_Court);

		while ((Choix_Vol_Long_Court!=1) && (Choix_Vol_Long_Court!=2))
		{
		printf("\nVous avez fait un mauvais choix. Recommencer.\n");
		printf("Voulez-vous un vol: court (inclinaison<90 entrer 1)\n");
		printf("                    ou long (inclinaison>=90 entrer 2)? ");
		scanf("%d",&Choix_Vol_Long_Court);
		}
		}

		if (SensParcours==0)
		{
		printf("Voulez-vous un vol: long (inclinaison<90 entrer 3) \n");
		printf("                    ou court (inclinaison>=90 entrer 4)? ");
		scanf("%d",&Choix_Vol_Long_Court);

		while ((Choix_Vol_Long_Court!=3) && (Choix_Vol_Long_Court!=4))
		{
		printf("\nVous avez fait un mauvais choix. Recommencer.\n");
		printf("Voulez-vous un vol: long (inclinaison<90 entrer 3)\n");
		printf("                    ou court (inclinaison>=90 entrer 4)? ");
		scanf("%d",&Choix_Vol_Long_Court);
		}

		}
	}


	/* CALCUL DE DELTA */

	if ( (Choix_Vol_Long_Court==1) || (Choix_Vol_Long_Court==4) )
	{
		Delta=Angle;
		for (int k=0; k<4; k++)
		W[k]=W12[k];
		Lambda= (sqrt(R1*R2)*cos(Delta/2))/S;
	}

	if ( (Choix_Vol_Long_Court==2) || (Choix_Vol_Long_Court==3) )
	{
		Delta=2*pi-Angle;
		multiplication_scalaire(-1,W12,W);
		Lambda=sqrt(R1*R2)*cos(Delta/2)/S;
	}

	solution_elliptique();

	}


/***************************************************************************
			FONCTION D'AFFICHAGE
***************************************************************************/

void afficher ()
{
	clrscr();
	char rep;


	//SAUVEGARDE DES DONNEES DANS UN FICHIER
	printf("Voulez-vous sauvegarder les rsultats dans un fichier (o/n):");
	scanf("%c",&rep);
	if ((rep=='O')||(rep=='o'))
	{
	char nomfichier[21];
	FILE * sortie;
	printf("\nVous allez saisir le nom du fichier de sauvegarde.\n");
	printf("\n\n                      ATTENTION:\n\n");
	printf("Pour viter tout problme, il est prfrable de placer ce dossier \n la racine de votre disque.\n");
	printf("\nLe nom du fichier doit contenir 8 caractres au maximum sans compter \nle nom de votre disque (c: ou d:) ni .txt.\n");
	printf("\n\nExemple de nom de fichier acceptable: c:/test.txt ou d:/essai1.txt\n");
	printf("\n\nEntrer le nom du fichier: ");


	scanf("%20s",&nomfichier);
	sortie=fopen(nomfichier,"w");

fprintf(sortie,"*******************************************************************************\n");
fprintf(sortie,"**                      PROJET: RESOLUTION DU PROBLEME DE LAMBERT            **\n");
fprintf(sortie,"**                         EMILIE CASTELLANI ET ISABELLE DAUVIN              **\n");
fprintf(sortie,"**                            PROMOTION 2002/2003 DU DESS TAE                **\n");
fprintf(sortie,"*******************************************************************************\n");

fprintf(sortie," \n\n\n                                 RAPPEL DE LA MISSION:\n\n");


	if ((azerty=='o')||(azerty=='O'))
	{
	fprintf(sortie, "Le nom de la mission est:\n");
	for (int y=0;y<=19;y++)fprintf(sortie,"%c",nom_mission[y]);
	}

	fprintf(sortie,"\n");


	if (Helios==1)
	fprintf(sortie,"Vous avez choisi un vol heliocentrique en %d tour(s).\n\n",NTour);
	if (Helios==0)
	fprintf(sortie,"Vous avez choisi un vol geocentrique en %d tour(s).\n\n",NTour);

	fprintf(sortie,"\n\n");
	fprintf(sortie,"La mission part du point:\n\n");
	fprintf(sortie,"X=%.1lf km\n",RayonVecteurDepart[1]);
	fprintf(sortie,"Y=%.1lf km\n",RayonVecteurDepart[2]);
	fprintf(sortie,"Y=%.1lf km\n\n",RayonVecteurDepart[3]);
	fprintf(sortie,"pour arriver au point:\n\n");
	fprintf(sortie,"X=%.1lf km\n",RayonVecteurArrivee[1]);
	fprintf(sortie,"Y=%.1lf km\n",RayonVecteurArrivee[2]);
	fprintf(sortie,"Y=%.1lf km\n",RayonVecteurArrivee[3]);





fprintf(sortie," \n                PARAMETRES ORBITAUX DE LA CONIQUE SOLUTION:\n\n");


	fprintf(sortie,"Demi grand axe: %20.1lf km\n\n",a);
	fprintf(sortie,"Excentricite: %21lf\n\n",excentricite);
	fprintf(sortie,"Inclinaison orbitale: %14.3lf deg\n\n",inclinaison);
	fprintf(sortie,"Rayon a l'apogee: %18.1lf km\n\n",ra);
	fprintf(sortie,"Rayon au perigee: %18.1lf km\n\n",rp);
	fprintf(sortie,"Longitude vernale: %17.lf deg\n\n", longitude*180/pi);
	fprintf(sortie,"Argument nodal au perigee: %8.1lf deg\n\n",argument*180/pi);
	fprintf(sortie,"Anomalie moyenne: %18.3lf deg\n\n",M);
	fprintf(sortie,"Duree du voyage: %19lf jours decimaux\n\n",Delta_T);
	fprintf(sortie,"Duree minimale du voyage: %9lf jours decimaux\n\n",DureeMini);
	fprintf(sortie,"Anomalie excentrique en P1: %7.3lf\n\n",phi1*180/pi);
	fprintf(sortie,"Anomalie excentrique en P2: %7.3lf\n\n",phi2*180/pi);
	fprintf(sortie,"Anomalie vraie au depart: %9.3lf deg\n\n",teta1);
	fprintf(sortie,"Anomalie vraie a l'arrivee: %7.3lf deg\n\n",teta2);
	fprintf(sortie,"Pente au depart: %19.3lf deg\n\n",gamma1);
	fprintf(sortie,"Pente a l'arrivee: %17.3lf deg\n\n",gamma2);

	fprintf(sortie,"\n\n");


fprintf(sortie,"indice 1: point de depart, indice 2: point d'arrivee\n\n");
fprintf(sortie,"Distance entre le foyer principal de l'orbite et P1: %.1lf km\n",R1);
fprintf(sortie,"Distance entre le foyer principal de l'orbite et P2: %.1lf km\n",R2);
	fprintf(sortie,"\n");


	switch (cas_de_vol)
	{
case 1:fprintf(sortie,"Cas de vol 1: ellipse, R1<R2, P1 et P2 montants, delta<90\n");
break;
case 2:fprintf(sortie,"Cas de vol 2: ellipse, R1<R2, P1 montant et P2 descendant, delta<90\n");
break;
case 3:fprintf(sortie,"Cas de vol 3: ellipse, R1<R2, P1 montant et P2 descendant, delta>90\n");
break;
case 4:fprintf(sortie,"Cas de vol 4: ellipse, R1<R2, P1 et P2 descendants, delta>90\n");
break;
case 5:fprintf(sortie,"Cas de vol 5: ellipse, R1<R2, P1 descendant et P2 montant, delta>90\n");
break;
case 6:fprintf(sortie,"Cas de vol 6: ellipse, R1>R2, P1 montant et P2 descendant, delta<90\n");
break;
case 7:fprintf(sortie,"Cas de vol 7: ellipse, R1>R2, P1 et P2 descendants, delta<90\n");
break;
case 8:fprintf(sortie,"Cas de vol 8: ellipse, R1>R2, P1 et P2 montants, delta>90\n");
break;
case 9:fprintf(sortie,"Cas de vol 9: ellipse, R1>R2, P1 descendant et P2 montant, delta>90\n");
break;
case 10:fprintf(sortie,"Cas de vol 10: ellipse, R1>R2, P1 descendant et P2 montant, delta<90\n");
break;
	}
	fprintf(sortie,"\n");


	switch (Choix_Vol_Long_Court)
	{
	case 1:fprintf(sortie,"Vous aviez choisi un voyage court.\n");
	break;
	case 2:fprintf(sortie,"Vous aviez choisi un voyage long.\n");
	break;
	case 3:fprintf(sortie,"Vous aviez choisi un voyage long.\n");
	break;
	case 4:fprintf(sortie,"Vous aviez choisi un voyage court.\n");
	break;
	}


	fprintf(sortie,"\n");

	fprintf(sortie,"Vitesse de depart (en km/s):\n\n");
	for (int l=1;l<=3;l++)
	fprintf(sortie,"v%d: %.4lf\n", l, vitesse1[l]);
	fprintf(sortie,"Norme de la vitesse  de depart:%.4lf km/s\n",Nvitesse1);
	fprintf(sortie,"\n");
	if (planete1==1)
	{
	fprintf(sortie,"vitesse infini a l'arrivee: %.4lf km/s\n",Vinfini2);
	}
	fprintf(sortie,"Vitesse d'arrivee (en km/s):\n\n");
	for (int j=1;j<=3;j++)
	fprintf(sortie,"v%d: %.4lf\n", j, vitesse2[j]);
	fprintf(sortie,"Norme de la vitesse d'arrivee: %.4lf km/s\n",Nvitesse2);
	if (planete2==1)
	{
	 fprintf(sortie,"Vitesse infini a l'arrivee: %.4lf km/s\n",Vinfini2);
	}
	fprintf(sortie,"\n");
	fclose(sortie);
	}



	getchar();
	clrscr();


	// AFFICHAGE A L'ECRAN

printf("\n\n\n\n");


printf("*******************************************************************************\n");
printf("**                                                                           **\n");
printf("**                                                                           **\n");
printf("**                      PROJET: RESOLUTION DU PROBLEME DE LAMBERT            **\n");
printf("**                                                                           **\n");
printf("**                         EMILIE CASTELLANI ET ISABELLE DAUVIN              **\n");
printf("**                                                                           **\n");
printf("**                            PROMOTION 2002/2003 DU DESS TAE                **\n");
printf("**                                                                           **\n");
printf("**                                                                           **\n");
printf("*******************************************************************************\n");

printf("\n\nAppuyez sur une touche.");
getchar();
clrscr();

printf(" \n                               RAPPEL DE LA MISSION:\n");
	printf("\n");


	if ((azerty=='o')||(azerty=='O'))
	{
	printf( "Le nom de la mission est:\n");
	for (int y=0;y<=19;y++)printf("%c",nom_mission[y]);
	}

	printf("\n");



	if (Helios==1)
	printf("Vous avez choisi un vol hliocentrique en %d tour(s).\n",NTour);
	if (Helios==0)
	printf("Vous avez choisi un vol gocentrique en %d tour(s).\n",NTour);

	printf("\n\n");
	printf("La mission part du point:\n\n");
	printf("X=%.1lf km\n",RayonVecteurDepart[1]);
	printf("Y=%.1lf km\n",RayonVecteurDepart[2]);
	printf("Y=%.1lf km\n\n",RayonVecteurDepart[3]);
	printf("pour arriver au point:\n\n");
	printf("X=%.1lf km\n",RayonVecteurArrivee[1]);
	printf("Y=%.1lf km\n",RayonVecteurArrivee[2]);
	printf("Y=%.1lf km\n",RayonVecteurArrivee[3]);

	printf("\n\n************* ATTENTION, NOTEZ LES RESULTATS QUI VONT ETRE EFFACES *************\n");

	getchar();

	clrscr();




	printf(" \n                PARAMETRES ORBITAUX DE LA CONIQUE SOLUTION:\n");
	printf("\n\n");

	printf("Demi grand axe: %20.1lf km\n\n",a);
	printf("Excentricit: %22lf\n\n",excentricite);
	printf("Inclinaison orbitale: %14.3lf\n\n",inclinaison);
	printf("Rayon  l'apoge: %18.1lf km\n\n",ra);
	printf("Rayon au prige: %18.1lf km\n\n",rp);
	printf("Longitude vernale: %17.3lf\n\n", longitude*180/pi);
	printf("Argument nodal au prige: %9.3lf\n\n",argument*180/pi);
	printf("Anomalie moyenne: %18.3lf\n\n",M);

	printf("\n\n************* ATTENTION, NOTEZ LES RESULTATS QUI VONT ETRE EFFACES *************\n");

	getchar();

	clrscr();
	printf(" \n                PARAMETRES ORBITAUX DE LA CONIQUE SOLUTION:\n");
	printf("\n\n");

	printf("Dure du voyage: %20lf jours dcimaux\n",Delta_T);
	printf("Dure minimale du voyage: %11lf jours dcimaux\n\n",DureeMini);
	printf("Anomalie excentrique en P1: %7.3lf\n",phi1*180/pi);
	printf("Anomalie excentrique en P2: %7.3lf\n\n",phi2*180/pi);
	printf("Anomalie vraie en P1: %13.3lf\n",teta1);
	printf("Anomalie vraie en P2: %13.3lf\n\n",teta2);
	printf("Pente de la vitesse en P1: %8.3lf\n",gamma1);
	printf("Pente de la vitesse en P2: %8.3lf\n\n",gamma2);







printf("************* ATTENTION, NOTEZ LES RESULTATS QUI VONT ETRE EFFACES *************\n");

	getchar();

	clrscr();



	printf(" \n                PARAMETRES ORBITAUX DE LA CONIQUE SOLUTION:\n");
	printf("\n");

	printf("indice 1: point de dpart, indice 2: point d'arrive\n\n");
printf("Distance entre le foyer principal de l'orbite et P1: %.1lf km\n",R1);
printf("Distance entre le foyer principal de l'orbite et P2: %.1lf km\n",R2);
	printf("\n");


	switch (cas_de_vol)
	{
case 1:printf("Cas de vol n1: ellipse, R1<R2, P1 et P2 montants, delta<90\n");
break;
case 2:printf("Cas de vol n2: ellipse, R1<R2, P1 montant et P2 descendant, delta<90\n");
break;
case 3:printf("Cas de vol n3: ellipse, R1<R2, P1 montant et P2 descendant, delta>90\n");
break;
case 4:printf("Cas de vol n4: ellipse, R1<R2, P1 et P2 descendants, delta>90\n");
break;
case 5:printf("Cas de vol n5: ellipse, R1<R2, P1 descendant et P2 montant, delta>90\n");
break;
case 6:printf("Cas de vol n6: ellipse, R1>R2, P1 montant et P2 descendant, delta<90\n");
break;
case 7:printf("Cas de vol n7: ellipse, R1>R2, P1 et P2 descendants, delta<90\n");
break;
case 8:printf("Cas de vol n8: ellipse, R1>R2, P1 et P2 montants, delta>90\n");
break;
case 9:printf("Cas de vol n9: ellipse, R1>R2, P1 descendant et P2 montant, delta>90\n");
break;
case 10:printf("Cas de vol n10: ellipse, R1>R2, P1 descendant et P2 montant, delta<90\n");
break;
	}



	switch (Choix_Vol_Long_Court)
	{
	case 1:printf("Vous aviez choisi un voyage court.\n");
	break;
	case 2:printf("Vous aviez choisi un voyage long.\n");
	break;
	case 3:printf("Vous aviez choisi un voyage long.\n");
	break;
	case 4:printf("Vous aviez choisi un voyage court.\n");
	break;
	}


	printf("\n");

	printf("Vitesse de dpart (en km/s):\n");
	for (int i=1;i<=3;i++)
	printf("v%d: %.4lf\n", i, vitesse1[i]);
	printf("Norme de la vitesse  de dpart:%.4lf km/s\n",Nvitesse1);
	if(planete1==1)
	{
	printf("Vitesse infini au depart: %.4lf km/s\n",Vinfini1);
	}
	printf("\n");
	printf("Vitesse d'arrive (en km/s):\n");
	for (int j=1;j<=3;j++)
	printf("v%d: %.4lf\n", j, vitesse2[j]);
	printf("Norme de la vitesse d'arrive: %.4lf km/s\n",Nvitesse2);
	if(planete2==1)
	{
	printf("Vitesse infini a l'arrivee: %.4lf km/s\n",Vinfini2);
	}


	printf("************* ATTENTION, NOTEZ LES RESULTATS ");
	printf("QUI VONT ETRE EFFACES *************");

	getchar();

}





void main()
{
	clrscr();
	void saisir();
	void afficher();


	encore='o';

while ((encore=='o') || (encore=='O'))
{
	saisir();

	if (NTour==0)
	{
	getchar();
	clrscr();

	printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n               ");
	printf("  ON EST A ZERO TOUR. IL N'Y A DONC QU'UNE SOLUTION.\n");
	printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
	printf("Appuyez sur une touche.\n");
	getchar();



	choix= solution_equation_elliptique_0_tour();
	Solution_du_probleme(choix);
	classification_des_cas();
	traitement_cas_vol(cas_de_vol);
	dernier_parametre ();
	afficher();
	}
	else
	{
	getchar();
	clrscr();
	printf("\n\n\n\n\n\n\n\n\n\n\n\n\n");
	printf("ON EST A PLUS D'UN TOUR.");
	printf("IL Y A DONC DEUX SOLUTIONS POSSIBLES.\n");
	printf("\n\n\n\n\n\n\n                       ");
	printf("              VOICI LA PREMIERE SOLUTION.\n\n\n\n\n\n\n\n");

	printf("Appuyez sur une touche.");
	getchar();


	clrscr();
	choix=premiere_solution_NTour();
	Solution_du_probleme(choix);
	classification_des_cas();
	traitement_cas_vol(cas_de_vol);
	dernier_parametre();
	afficher();

	clrscr();
	printf("\n\n\n\n\n\n\n\n\n\n\n\n                ");
	printf("     VOICI LA DEUXIEME SOLUTION.\n\n\n\n\n\n\n\n\n");
	printf("Appuyez sur une touche.");
	getchar();




	choix=deuxieme_solution_NTour();
	Solution_du_probleme(choix);
	classification_des_cas();
	traitement_cas_vol(cas_de_vol);
	dernier_parametre();
	afficher();
	}

	printf("Voulez-vous relancer le programme pour une autre mission? (o/n):");
	scanf("%c",&encore);
	if ((encore=='n')||(encore=='N'))
	{exit(EXIT_SUCCESS);}
	else clrscr();


}
}